//+------------------------------------------------------------------+
//|                                            OKhsl Screenshots.mq5 |
//|                                  Copyright 2023, Maxim Savochkin |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2023, Maxim Savochkin"
#property link      "https://www.mql5.com"
#property version   "1.00"
#include  <Canvas/Canvas.mqh>
#include  <OK Color Space.mqh>

CCanvas scale_1;
CCanvas scale_2;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   int chart_width=(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0);
   int chart_height=(int)ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0);
   RectLabelCreate("BG",0,0,0,chart_width,chart_height,clrGray,clrNONE,0,0);
   RectLabelCreate("BG-1",0,99,99,752,352,clrWhite,clrNONE,0,0);
   
   //RectLabelCreate("S-1-BORDER",0,248,188,554,74,clrDarkGray,clrNONE,0,0);
   //RectLabelCreate("S-2-BORDER",0,248,328,554,74,clrDarkGray,clrNONE,0,0);
   scale_1.CreateBitmapLabel(0,0,"S-1",250,190,550,70,COLOR_FORMAT_XRGB_NOALPHA);
   scale_2.CreateBitmapLabel(0,0,"S-2",250,330,550,70,COLOR_FORMAT_XRGB_NOALPHA);
   
   EditCreate("HUE",0,425,115,100,50,"Hue",16,"Consolas Bold",ALIGN_CENTER,true,clrBlack,clrWhite,0);
   //EditCreate("LIGHTNESS",0,325,115,300,50,"Lightness",16,"Consolas Bold",ALIGN_CENTER,true,clrBlack,clrWhite,0);
   EditCreate("OKHSL",0,120,190,100,70,"OKhsl:",14,"Consolas Bold",ALIGN_LEFT,true,clrBlack,clrWhite,0);
   EditCreate("HSL",0,120,330,100,70,"HSL:",14,"Consolas Bold",ALIGN_LEFT,true,clrBlack,clrWhite,0);
   
   uint  clr;
   float h_coeff=360.f/550.f;
   for(int x=0; x<550; x++)
     {
      clr=ColorToARGB(OKhslToColor(x*h_coeff,95.f,65.f));
      for(int y=0; y<70; y++)
        {
         scale_1.PixelSet(x,y,clr);
        }
     }
   for(int x=0; x<550; x++)
     {
      clr=ColorToARGB(HSLToColor(x*h_coeff,90.f,60.f));
      for(int y=0; y<70; y++)
        {
         scale_2.PixelSet(x,y,clr);
        }
     }
   
   /*float l_coeff=100.f/550.f;
   for(int x=0; x<550; x++)
     {
      clr=ColorToARGB(OKhslToColor(274.f,100.f,x*l_coeff));
      for(int y=0; y<70; y++)
        {
         scale_1.PixelSet(x,y,clr);
        }
     }
   for(int x=0; x<550; x++)
     {
      clr=ColorToARGB(HSLToColor(255.f,100.f,x*l_coeff));
      for(int y=0; y<70; y++)
        {
         scale_2.PixelSet(x,y,clr);
        }
     }*/
   
   scale_1.Update();
   scale_2.Update();
   
   ChartRedraw();
//---
   //ChartScreenShot(0,"OK Color Space - HUE.bmp",chart_width,chart_height,ALIGN_LEFT);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   ObjectDelete(0,"BG");
   ObjectDelete(0,"BG-1");
   //ObjectDelete(0,"LIGHTNESS");
   ObjectDelete(0,"HUE");
   ObjectDelete(0,"OKHSL");
   ObjectDelete(0,"HSL");
   //ObjectDelete(0,"S-1-BORDER");
   //ObjectDelete(0,"S-2-BORDER");
   scale_1.Destroy();
   scale_2.Destroy();
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| RectLabelCreate                                                  |
//+------------------------------------------------------------------+
void RectLabelCreate(
                     const string name,
                     const int    sub_window,
                     const int    x,
                     const int    y,
                     const int    width,
                     const int    height,
                     const color  back_clr,
                     const color  border_clr,
                     const int    border_width,
                     const long   z_order
                    )
  { 
   if(!ObjectCreate(0,name,OBJ_RECTANGLE_LABEL,sub_window,0,0)) {Alert("Error: \""+name+"\" can not be created.");}
   ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x); 
   ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y); 
   ObjectSetInteger(0,name,OBJPROP_XSIZE,width); 
   ObjectSetInteger(0,name,OBJPROP_YSIZE,height); 
   ObjectSetInteger(0,name,OBJPROP_BGCOLOR,back_clr); 
   ObjectSetInteger(0,name,OBJPROP_COLOR,border_clr); 
   ObjectSetInteger(0,name,OBJPROP_BORDER_TYPE,BORDER_FLAT); 
   ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER); 
   ObjectSetInteger(0,name,OBJPROP_WIDTH,border_width); 
   ObjectSetInteger(0,name,OBJPROP_BACK,false); 
   ObjectSetInteger(0,name,OBJPROP_SELECTABLE,false); 
   ObjectSetInteger(0,name,OBJPROP_SELECTED,false); 
   ObjectSetInteger(0,name,OBJPROP_HIDDEN,true); 
   ObjectSetInteger(0,name,OBJPROP_ZORDER,z_order); 
  }
//+------------------------------------------------------------------+
//| EditCreate                                                       |
//+------------------------------------------------------------------+
bool EditCreate(
                const string          name,
                const int             sub_window,
                const int             x,
                const int             y,
                const int             width,
                const int             height,
                const string          text,
                const int             font_size,
                const string          font_name,
                const ENUM_ALIGN_MODE align,
                const bool            read_only,
                const color           clr,
                const color           back_clr,
                const long            z_order
               )
  { 
   if(!ObjectCreate(0,name,OBJ_EDIT,sub_window,0,0)) {Alert("Error: \""+name+"\" can not be created.");}
   ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x); 
   ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y); 
   ObjectSetInteger(0,name,OBJPROP_XSIZE,width); 
   ObjectSetInteger(0,name,OBJPROP_YSIZE,height); 
   ObjectSetString(0,name,OBJPROP_TEXT,text); 
   ObjectSetString(0,name,OBJPROP_FONT,font_name); 
   ObjectSetInteger(0,name,OBJPROP_FONTSIZE,font_size); 
   ObjectSetInteger(0,name,OBJPROP_ALIGN,align); 
   ObjectSetInteger(0,name,OBJPROP_READONLY,read_only); 
   ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER); 
   ObjectSetInteger(0,name,OBJPROP_COLOR,clr); 
   ObjectSetInteger(0,name,OBJPROP_BGCOLOR,back_clr); 
   ObjectSetInteger(0,name,OBJPROP_BORDER_COLOR,back_clr); 
   ObjectSetInteger(0,name,OBJPROP_BACK,false); 
   ObjectSetInteger(0,name,OBJPROP_SELECTABLE,false); 
   ObjectSetInteger(0,name,OBJPROP_SELECTED,false); 
   ObjectSetInteger(0,name,OBJPROP_HIDDEN,true); 
   ObjectSetInteger(0,name,OBJPROP_ZORDER,z_order); 
   return(true); 
  }
//+------------------------------------------------------------------+
//| HSLToColor                                                       |
//+------------------------------------------------------------------+
color HSLToColor(
                 float h,
                 float s,
                 float l
                )
  {
   float H = h / 360.f;
   float S = s / 100.f;
   float L = l / 100.f;
   float R, G, B;
   float var_1, var_2;
   
   if ( S == 0 )
   {
      R = L * 255.f;
      G = L * 255.f;
      B = L * 255.f;
   }
   else
   {
      if ( L < 0.5f ) var_2 = L * ( 1.f + S );
      else            var_2 = ( L + S ) - ( S * L );
   
      var_1 = 2.f * L - var_2;
   
      R = 255.f * hue_2_rgb( var_1, var_2, H + ( 1.f / 3.f ) );
      G = 255.f * hue_2_rgb( var_1, var_2, H );
      B = 255.f * hue_2_rgb( var_1, var_2, H - ( 1.f / 3.f ) );
   }
   return( (uchar(MathRound(B))<<16) | (uchar(MathRound(G))<<8) | (uchar(MathRound(R))) );
  }
//+------------------------------------------------------------------+
//| hue_2_rgb                                                        |
//+------------------------------------------------------------------+
float hue_2_rgb(
                float v1,
                float v2,
                float vH
               )
  {
   if ( vH < 0.f ) vH += 1.f;
   if ( vH > 1.f ) vH -= 1.f;
   if ( ( 6.f * vH ) < 1.f ) return ( v1 + ( v2 - v1 ) * 6.f * vH );
   if ( ( 2.f * vH ) < 1.f ) return ( v2 );
   if ( ( 3.f * vH ) < 2.f ) return ( v1 + ( v2 - v1 ) * ( ( 2.f / 3.f ) - vH ) * 6.f );
   return ( v1 );
  }
//+------------------------------------------------------------------+
